unit MDIMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ToolWin, ImgList, ExtCtrls, StdCtrls, MDITab;

type
  TfrmMain = class(TForm)
    MainMenu: TMainMenu;
    ImageList: TImageList;
    sd: TSaveDialog;
    od: TOpenDialog;
    mmFile: TMenuItem;
    mmWin: TMenuItem;
    mmHelp: TMenuItem;
    mmOpen: TMenuItem;
    mmReopen: TMenuItem;
    mmSave: TMenuItem;
    mmSaveAs: TMenuItem;
    mmClose: TMenuItem;
    mmCloseAll: TMenuItem;
    N1: TMenuItem;
    mmExit: TMenuItem;
    mmMinAll: TMenuItem;
    mmAbout: TMenuItem;
    mmNew: TMenuItem;
    mmCascade: TMenuItem;
    mmTileHor: TMenuItem;
    mmTileVer: TMenuItem;
    pd: TPrintDialog;
    psd: TPrinterSetupDialog;
    N2: TMenuItem;
    mmPrintSetup: TMenuItem;
    mmPrint: TMenuItem;
    ControlBar: TControlBar;
    ToolBar: TToolBar;
    sbNew: TToolButton;
    sbOpen: TToolButton;
    sbSave: TToolButton;
    sbPrint: TToolButton;
    ToolButton8: TToolButton;
    sbClose: TToolButton;
    sbCascade: TToolButton;
    sbTileHor: TToolButton;
    sbTileVer: TToolButton;
    ToolButton4: TToolButton;
    sbAbout: TToolButton;
    sbExit: TToolButton;
    MDITab1: TMDITab;
    sb: TStatusBar;
    mmView: TMenuItem;
    mmToolbar: TMenuItem;
    mmWindowBar: TMenuItem;
    mmStatusBar: TMenuItem;
    PopupMenu1: TPopupMenu;
    Flat1: TMenuItem;
    Buttons1: TMenuItem;
    Tabs1: TMenuItem;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cmCloseAll(Sender: TObject);
    procedure cmOpen(Sender: TObject);
    procedure cmClose(Sender: TObject);
    procedure cmExit(Sender: TObject);
    procedure cmMinAll(Sender: TObject);
    procedure cmNew(Sender: TObject);
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure cmCascade(Sender: TObject);
    procedure cmTileHor(Sender: TObject);
    procedure cmTileVer(Sender: TObject);
    procedure cmPrint(Sender: TObject);
    procedure cmPrintSetup(Sender: TObject);
    procedure cmToolbar(Sender: TObject);
    procedure cmWindowBar(Sender: TObject);
    procedure cmStatusBar(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmStyle(Sender: TObject);
  private
  public
    procedure OpenFile(const fn :string);
  end;

var
  frmMain: TfrmMain;

implementation
uses MDIChild;

{$R *.DFM}

procedure TfrmMain.OpenFile;
var
  child :tfrmchild;
begin
  if fileexists(fn) then begin
    child:=tfrmchild.create(self);
    child.filename:=fn;
    mditab1.addtab(child,10);
  end else
    MessageDlg('Cannot open file '+fn+'.',mtError,[mbOK],0);
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  cmcloseall(sender);
end;

procedure TfrmMain.cmCloseAll(Sender: TObject);
begin
  mditab1.closeall;
end;

procedure TfrmMain.cmClose(Sender: TObject);
begin
  if mdichildcount>0 then
    activemdichild.close;
end;

procedure TfrmMain.cmExit(Sender: TObject);
begin
  close;
end;

procedure TfrmMain.cmMinAll(Sender: TObject);
begin
  mditab1.minimizeall;
end;

procedure TfrmMain.cmNew(Sender: TObject);
var
  child :tfrmchild;
begin
  child:=tfrmchild.create(self);
  child.caption:='Child #'+inttostr(frmmain.mdichildcount);
  mditab1.addtab(child,10);
end;

procedure TfrmMain.AppIdle(Sender: TObject; var Done: Boolean);
begin
  mmsave.enabled:=(mdichildcount>0) {and tfrmchild(activemdichild).modified};
  mmsaveas.enabled:=mdichildcount>0;
  mmclose.enabled:=mdichildcount>0;
  mmcloseall.enabled:=mdichildcount>0;
  mmminall.enabled:=mdichildcount>0;
  mmcascade.enabled:=mdichildcount>0;
  mmtilehor.enabled:=mdichildcount>0;
  mmtilever.enabled:=mdichildcount>0;
  mmprint.enabled:=mdichildcount>0;
  mmtoolbar.checked:=toolbar.visible;
  mmwindowbar.checked:=mditab1.visible;
  mmstatusbar.checked:=sb.visible;
  sbsave.enabled:=mmsave.enabled;
  sbclose.enabled:=mmclose.enabled;
  sbcascade.enabled:=mmcascade.enabled;
  sbtilehor.enabled:=mmtilehor.enabled;
  sbtilever.enabled:=mmtilever.enabled;
  sbprint.enabled:=mmprint.enabled;
end;

procedure TfrmMain.cmCascade(Sender: TObject);
begin
  cascade;
end;

procedure TfrmMain.cmTileHor(Sender: TObject);
begin
  tilemode:=tbhorizontal;
  tile;
end;

procedure TfrmMain.cmTileVer(Sender: TObject);
begin
  tilemode:=tbvertical;
  tile;
end;

procedure TfrmMain.cmPrint(Sender: TObject);
begin
  if mdichildcount>0 then
    with tfrmchild(activemdichild) do begin
      if pd.execute then begin

      end;
    end;
end;

procedure TfrmMain.cmPrintSetup(Sender: TObject);
begin
  psd.execute;
end;

procedure TfrmMain.cmToolbar(Sender: TObject);
begin
  toolbar.visible:=not toolbar.visible;
end;

procedure TfrmMain.cmWindowBar(Sender: TObject);
begin
  mditab1.visible:=not mditab1.visible;
end;

procedure TfrmMain.cmStatusBar(Sender: TObject);
begin
  sb.visible:=not sb.visible;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  if mditab1.parent is tcontrolbar then
    mditab1.width:=width;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  application.OnIdle:=appidle;
end;

procedure TfrmMain.cmOpen(Sender: TObject);
begin
  if od.execute then
    openfile(od.filename);
end;

procedure TfrmMain.cmStyle(Sender: TObject);
begin
  mditab1.style:=ttabstyle(tcomponent(sender).tag);
  tmenuitem(sender).checked:=true;
end;

end.
